import pandas as pd

class _FiinIndicator:
    class trend:
        class EMA:
            def __init__(self, column: pd.Series, window: int) -> None: ...
            def ema(self) -> pd.Series: ...

        class SMA:
            def __init__(self, column: pd.Series, window: int) -> None: ...
            def sma(self) -> pd.Series: ...

        class WMA:
            def __init__(self, close: pd.Series, window: int = 9) -> None: ...
            def wma(self) -> pd.Series: ...

        class MACD:
            def __init__(self, column: pd.Series, window_slow: int = 26, window_fast: int = 12, window_sign: int = 9) -> None: ...
            def macd(self) -> pd.Series: ...
            def macd_signal(self) -> pd.Series: ...
            def macd_diff(self) -> pd.Series: ...

        class ADX:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> None: ...
            def adx(self) -> pd.Series: ...
            def adx_pos(self) -> pd.Series: ...
            def adx_neg(self) -> pd.Series: ...

        class PSAR:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, step: float = 0.02, max_step = 0.2) -> None: ...
            def psar(self) -> pd.Series: ...

        class Ichimoku:
            def __init__(self, high: pd.Series, low: pd.Series, window1: int = 9, window2: int = 26, window3: int = 52) -> None: ...
            def ichimoku_a(self) -> pd.Series: ...           
            def ichimoku_b(self) -> pd.Series: ...
            def ichimoku_base_line(self) -> pd.Series: ...
            def ichimoku_base_line(self) -> pd.Series: ...
            def ichimoku_conversion_line(self) -> pd.Series: ...

        class CCI:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 20, constant: float = 0.015) -> None: ...
            def cci(self) -> pd.Series: ...
        
        class Aroon:
            def __init__(self, high: pd.Series, low: pd.Series, window: int = 25) -> None: ...
            def aroon(self) -> pd.Series: ...
            def aroon_up(self) -> pd.Series: ...
            def aroon_down(self) -> pd.Series: ...

    class momentum:
        class RSI:
            def __init__(self, column: pd.Series, window: int = 14) -> None: ...
            def rsi(self) -> pd.Series: ...

        class Stochastic:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, smooth_window: int = 3) -> None: ...
            def stoch(self) -> pd.Series: ...
            def stoch_signal(self) -> pd.Series: ...

    class volatility:
        class BollingerBands:
            def __init__(self, column: pd.Series, window: int = 20, window_dev: int = 2) -> None: ...
            def bollinger_hband(self) -> pd.Series: ...
            def bollinger_lband(self) -> pd.Series: ...

        class Supertrend:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, multiplier: float = 3.0) -> None: ...
            def supertrend(self) -> pd.Series: ...
            def supertrend_hband(self) -> pd.Series: ...
            def supertrend_lband(self) -> pd.Series: ...

        class ATR:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> None: ...
            def atr(self) -> pd.Series: ...

    class volume:
        class MFI:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> None: ...
            def mfi(self) -> pd.Series: ...

        class OBV:
            def __init__(self, column: pd.Series, volume: pd.Series) -> None: ...
            def obv(self) -> pd.Series: ...

        class VWAP:
            def __init__(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> None: ...
            def vwap(self) -> pd.Series: ...


    def ema(self, column: pd.Series, window: int) -> pd.Series: ...

    def sma(self, column: pd.Series, window: int) -> pd.Series: ...
    
    def wma(self, column: pd.Series, window: int) -> pd.Series: ...

    def macd(self, column: pd.Series, window_slow: int = 26, window_fast: int = 12) -> pd.Series: ...
    
    def macd_signal(self, column: pd.Series, window_slow: int = 26, window_fast: int = 12, window_sign: int = 9) -> pd.Series: ...
    
    def macd_diff(self, column: pd.Series, window_slow: int = 26, window_fast: int = 12, window_sign: int = 9) -> pd.Series: ...
    
    def adx(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> pd.Series: ...
    
    def adx_pos(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> pd.Series: ...
    
    def adx_neg(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> pd.Series: ...
    
    def psar(self, high: pd.Series, low: pd.Series, close: pd.Series, step: float = 0.02, max_step: float = 0.2) -> pd.Series: ...

    def ichimoku_a(self, high: pd.Series, low: pd.Series, window1: int = 9, window2: int = 26, window3: int = 52) -> pd.Series: ...

    def ichimoku_b(self, high: pd.Series, low: pd.Series, window1: int = 9, window2: int = 26, window3: int = 52) -> pd.Series: ...
    
    def ichimoku_base_line(self, high: pd.Series, low: pd.Series, window1: int = 9, window2: int = 26, window3: int = 52) -> pd.Series: ...

    def ichimoku_conversion_line(self, high: pd.Series, low: pd.Series, window1: int = 9, window2: int = 26, window3: int = 52) -> pd.Series: ...

    def cci(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 20, constant: float = 0.015) -> pd.Series: ...

    def aroon(self, high: pd.Series, low: pd.Series, window: int = 25) -> pd.Series: ...
    
    def aroon_up(self, high: pd.Series, low: pd.Series, window: int = 25) -> pd.Series: ...
    
    def aroon_down(self, high: pd.Series, low: pd.Series, window: int = 25) -> pd.Series: ...

    def rsi(self, column: pd.Series, window: int = 14) -> pd.Series: ...

    def stoch(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> pd.Series: ...
  
    def stoch_signal(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, smooth_window: int = 3) -> pd.Series: ...
    
    def bollinger_hband(self, column: pd.Series, window: int = 20, window_dev: int = 2) -> pd.Series: ...
    
    def bollinger_lband(self, column: pd.Series, window: int = 20, window_dev: int = 2) -> pd.Series: ...
    
    def supertrend(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, multiplier: float = 3.0) -> pd.Series: ...
    
    def supertrend_hband(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, multiplier: float = 3.0) -> pd.Series: ...
   
    def supertrend_lband(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14, multiplier: float = 3.0) -> pd.Series: ...

    def atr(self, high: pd.Series, low: pd.Series, close: pd.Series, window: int = 14) -> pd.Series: ...
   
    def mfi(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> pd.Series: ...
  
    def obv(self, column: pd.Series, volume: pd.Series) -> pd.Series: ...

    def vwap(self, high: pd.Series, low: pd.Series, close: pd.Series, volume: pd.Series, window: int = 14) -> pd.Series: ...
